/**
 * \file
 * \brief Dummy SCOP Transport module (SCOP Interface)
 */

/* TODO : error checking */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <err.h>
#include <errno.h>

#include "scop.h"


int scopTransportInit()
{
#ifdef TRACE
  DEBUG_indent += 2;
  for(DEBUG_i=0; DEBUG_i<(DEBUG_indent-2); DEBUG_i+=2, printf("| "));
  printf("|-TRACE: %s()\n",__FUNCTION__);
#endif

  return 0;
}

void scopTransportRead(char * buffer, int len)
{
  /* DEBUG PURPOSE ONLY */
  static int i = 0;

  /* DEBUG PURPOSE ONLY */
#define INIT_DEBUG_LEN     32
#define DATA_DEBUG_LEN     190
#define RT_DATA_DEBUG_LEN  235

  /* DEBUG purpose only */
  char init_debug_msg[INIT_DEBUG_LEN] = "1.0?ScopInitRequest?tcId?TC_0001";
  char data_debug_msg[DATA_DEBUG_LEN] = "1.0?ScopDataRequest?cmd?sendViaIut?\
data????6AB0001200103A40\
200106605503276B0000000000000004\
200106605503276Bacacacfffe276B52\
8000085d46a4000042369c39000648a7?\
1.0?ScopDataRequest?cmd?getViaIut";

  char rt_data_debug_msg[RT_DATA_DEBUG_LEN] = "1.0?ScopDataRequest?cmd?sendViaIut?data????";
  
  /* DEBUG purpose only */  
  strcpy(&rt_data_debug_msg[43],"6000000000382b80");                  /* IPv6 hdr (next=rthdr) */
  strcpy(&rt_data_debug_msg[59],"200106605503276A0000000000000004");  /* src addr              */
/*   strcpy(&rt_data_debug_msg[59],"200106605503276AACACACFFFE276A21");  /\* src addr              *\/ */
  strcpy(&rt_data_debug_msg[91],"200106605503276AACACACFFFE276A51");  /* hop1 addr             */
  strcpy(&rt_data_debug_msg[123],"3A04000200000000");                 /* rt hdr (next=icmpv6)  */
  strcpy(&rt_data_debug_msg[139],"200106605503276B0000000000000004"); /* hop2 addr             */
  strcpy(&rt_data_debug_msg[171],"200106605503276AACACACFFFE276A31"); /* dst addr              */
  strcpy(&rt_data_debug_msg[203],"8000085d46a4000042369c39000648a7"); /* echo request          */

  /* DEBUG purpose only */
  rt_data_debug_msg[3]=(unsigned char)0x0F;         /* len(ScopDataRequest)  */
  rt_data_debug_msg[19]=(unsigned char)0x03;        /* len(cmd)              */
  rt_data_debug_msg[23]=(unsigned char)0x0A;        /* len(sendViaIut)       */
  rt_data_debug_msg[34]=(unsigned char)0x04;        /* len(data)             */

  /* DEBUG purpose only */
  rt_data_debug_msg[39]=(unsigned char)0x00;        /* len(data)             */
  rt_data_debug_msg[40]=(unsigned char)0x00;        /* len(data)             */
  rt_data_debug_msg[41]=(unsigned char)0x00;        /* len(data)             */
  rt_data_debug_msg[42]=(unsigned char)0xC0;        /* len(data)             */

  /* DEBUG purpose only */
  init_debug_msg[3]=(unsigned char)0x0F;            /* len(ScopInitRequest)  */
  init_debug_msg[19]=(unsigned char)0x04;           /* len(tcId)             */
  init_debug_msg[24]=(unsigned char)0x07;           /* len(TC_0001)          */

  /* DEBUG purpose only */
  data_debug_msg[3]=(unsigned char)0x0F;            /* len(ScopDataRequest)  */
  data_debug_msg[19]=(unsigned char)0x03;
  data_debug_msg[23]=(unsigned char)0x0A;
  data_debug_msg[34]=(unsigned char)0x04;
  data_debug_msg[39]=(unsigned char)0x00;
  data_debug_msg[40]=(unsigned char)0x00;
  data_debug_msg[41]=(unsigned char)0x00;
  data_debug_msg[42]=(unsigned char)0x70;
  data_debug_msg[155]=(unsigned char)0x00;
  data_debug_msg[159]=(unsigned char)0x0F;
  data_debug_msg[175]=(unsigned char)0x03;
  data_debug_msg[179]=(unsigned char)0x09;


#ifdef TRACE
  DEBUG_indent += 2;
  for(DEBUG_i=0; DEBUG_i<(DEBUG_indent-2); DEBUG_i+=2, printf("| "));
  printf("|-TRACE: %s()\n",__FUNCTION__);
#endif

  /* DEBUG PURPOSE ONLY*/
/*   if(i>RT_DATA_DEBUG_LEN) */
/*     { */
/*       exit(0); */
/*     } */
/*   strncpy(buffer, &(rt_data_debug_msg[i]), len); */

  /* DEBUG PURPOSE ONLY*/
  if(i>DATA_DEBUG_LEN)
    {
      exit(0);
    }
  strncpy(buffer, &(data_debug_msg[i]), len);

  /* DEBUG PURPOSE ONLY*/
/*   if(i>INIT_DEBUG_LEN) */
/*     { */
/*       exit(0); */
/*     } */
/*   strncpy(buffer, &(init_debug_msg[i]), len); */


  i += len;

  return;
}

void scopTransportSend(char * buffer, int len)
{
#ifdef TRACE
  DEBUG_indent += 2;
  for(DEBUG_i=0; DEBUG_i<(DEBUG_indent-2); DEBUG_i+=2, printf("| "));
  printf("|-TRACE: %s()\n",__FUNCTION__);
#endif

  return;
}

void scopTransportSynchro(char *magic)
{
#ifdef TRACE
  DEBUG_indent += 2;
  for(DEBUG_i=0; DEBUG_i<(DEBUG_indent-2); DEBUG_i+=2, printf("| "));
  printf("|-TRACE: %s()\n",__FUNCTION__);
#endif

  return;
}

